org.apache.tinkerpop.gremlin.process.computer.bulkdumping

## Class BulkDumperVertexProgram

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.bulkdumping.BulkDumperVertexProgram

- All Implemented Interfaces:
    Cloneable, VertexProgram<Tuple>

      public class BulkDumperVertexProgram
      extends Object
      implements VertexProgram<Tuple>

  Author:
    Daniel Kuppitz (http://gremlin.guru)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `BulkDumperVertexProgram.Builder`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Features`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static BulkDumperVertexProgram.Builder` | `build()`
    `VertexProgram<Tuple>` | `clone()` When multiple workers on a single machine need VertexProgram instances, it is possible to use clone.
    `void` | `execute(Vertex sourceVertex, Messenger<Tuple> messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getFeatures, getMapReducers, getMemoryComputeKeys, getMessageCombiner, getTraverserRequirements, getVertexComputeKeys, loadState, storeState, workerIterationEnd, workerIterationStart`

- - ### Method Detail

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Specified by:
        `setup` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### execute

          public void execute(Vertex sourceVertex,
                              Messenger<Tuple> messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Specified by:
        `execute` in interface `VertexProgram<Tuple>`
      Parameters:
        `sourceVertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Specified by:
        `terminate` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Specified by:
        `getMessageScopes` in interface `VertexProgram<Tuple>`
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### clone

          public VertexProgram<Tuple> clone()

      Description copied from interface: `VertexProgram`
      When multiple workers on a single machine need VertexProgram instances, it is possible to use clone. This will provide a speedier way of generating instances, over the `VertexProgram.storeState(Configuration)` and `VertexProgram.loadState(org.apache.tinkerpop.gremlin.structure.Graph, Configuration)` model. The default implementation simply returns the object as it assumes that the VertexProgram instance is a stateless singleton.
      Specified by:
        `clone` in interface `VertexProgram<Tuple>`
      Overrides:
        `clone` in class `Object`
      Returns:
        A clone of the VertexProgram object

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

      Specified by:
        `getPreferredResultGraph` in interface `VertexProgram<Tuple>`

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

      Specified by:
        `getPreferredPersist` in interface `VertexProgram<Tuple>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### build

          public static BulkDumperVertexProgram.Builder build()

Copyright © 2013–2018 Apache Software Foundation. All rights reserved.